int maxI = 15000;
float currentBest;

#include <Servo.h>
#include <Math.h>

Servo servoFix;  // servo care va sta fix
Servo servoMobil;  // servo care va sta pe cel fix, de servoMobil se ataseaza panoul solar

float ScanPosition(){
  int sensorValue;
  float voltage;

  float sum = 0;
  for (int i=0; i < maxI; i++){
    sensorValue = analogRead(A0);
    voltage = sensorValue;
    
    sum += voltage;
  }
  sum /= maxI;
  Serial.println(sum);
  return sum;
}

float ScanForBestPosition2(){
 int waitTime = 200; //100
 servoFix.write(0);
 servoMobil.write(0);
 delay(waitTime);
 Serial.println("position 1:");
 float p1 = ScanPosition();

 servoFix.write(90);
 servoMobil.write(0);
 delay(waitTime);
 Serial.println("position 2:");
 float p2 = ScanPosition();

 servoFix.write(180);
 servoMobil.write(0);
 delay(waitTime);
 Serial.println("position 3:");
 float p3 = ScanPosition();

 servoFix.write(90);
 servoMobil.write(90);
 delay(waitTime);
 Serial.println("position 4:");
 float p4 = ScanPosition();

 servoFix.write(90);
 servoMobil.write(180);
 delay(waitTime);
 Serial.println("position 5:");
 float p5 = ScanPosition();

 float fa = min(p1, min(p2, min(p3, min(p4, p5))));
 p1 -= fa;
 p2 -= fa;
 p3 -= fa;
 p4 -= fa;
 p5 -= fa;

 float mfix = max(p1, p3);
 bool sw = false;
 if (p3 == mfix){
  sw = true;
 }

 int lfix = round( atan2 (p2, mfix) * 180/3.14159265 );

 if (sw){
  lfix = 180 - lfix;
 }

 int lm = round( atan2 (p4, mfix) * 180/3.14159265 );

 if (p5 > p2){
  lm = 180 - lm;
 }

 servoFix.write(lfix);
 servoMobil.write(lm);
 Serial.print("unghi fix");
 Serial.println(lfix);
 Serial.print("unghi mobil");
 Serial.println(lm);
 delay(100);
//
// Serial.print("unghi fix");
// Serial.println(lfix);
// Serial.print("unghi mobil");
// Serial.println(lm2);
// delay(100);
 
 return ScanPosition();
}

float ScanForBestPosition(){
  int waitTime = 1000; //100
  // scanez 5 pozitii si calculez valorile pentru fiecare dintre acestea
 servoFix.write(0);
 servoMobil.write(0);
 delay(waitTime);
 Serial.println("position 1:");
 float p1 = ScanPosition();

 servoFix.write(90);
 servoMobil.write(0);
 delay(waitTime);
 Serial.println("position 2:");
 float p2 = ScanPosition();

 servoFix.write(180);
 servoMobil.write(0);
 delay(waitTime);
 Serial.println("position 3:");
 float p3 = ScanPosition();

 servoFix.write(90);
 servoMobil.write(90);
 delay(waitTime);
 Serial.println("position 4:");
 float p4 = ScanPosition();

 servoFix.write(90);
 servoMobil.write(180);
 delay(waitTime);
 Serial.println("position 5:");
 float p5 = ScanPosition();

 // pentru alfa1, p1 p4 p3
 bool swap = false;
 if (p1 < p3){
   swap = true;
   
   float aux = p1;
   p1 = p3; 
   p3 = aux;
 }
 // new thing
 p1 = p1 - p3;
 p4 = p4-p3;
 int alfa1 = round( atan2 (p4, p1) * 180/3.14159265 );
 if (swap){
  alfa1 = 180 - alfa1;
 }
 p4 = p4 + p3;
 Serial.print("unghiul 1 este: ");
 Serial.println(alfa1);

 // pentru alfa2, p2, p4, p5

 swap = false;
 if (p2 < p5){
   swap = true;
   
   float aux = p2;
   p2 = p5; 
   p5 = aux;
 }
 
 int alfa2 = round( atan2 (p4, p2) * 180/3.14159265 );
 if (swap){
  alfa2 = 180 - alfa2;
 }
 Serial.print("unghiul 1 este: ");
 Serial.println(alfa2);

 servoFix.write(alfa1);
 servoMobil.write(alfa2);
 delay(100);
 return ScanPosition();
}

int currentState;
int nextState;
bool goToNextState;

#define INITIAL_STATE 1
#define SCAN_FOR_BEST_POSITION_ALGO 2
#define SCAN_FOR_BEST_POSITION_ITER 3
#define SCAN_FOR_RECALIBRATION 4

ISR(PCINT2_vect){
  Serial.print("test: ");
  Serial.println(PIND);
  Serial.println(1 << PD7);
//  Serial.println("am apasat butonul -- oricare");
  //if (PIND & (1 << PD7) == 0){
    //Serial.println("am apasat butonul");
    if (currentState == SCAN_FOR_RECALIBRATION || currentState == INITIAL_STATE){
      goToNextState = true;
    }
  //}
}


void setup() {
  // put your setup code here, to run once:
  Serial.begin(9600);
  servoFix.attach(5);
  servoMobil.attach(9);  
  currentState = INITIAL_STATE;
  goToNextState = false;
  pinMode(7, INPUT_PULLUP);
  cli();
  PCICR |= (1 << PCIE2);
  PCMSK2 |= (1 << PCINT23);
  sei();
}

void loop() {
  if (goToNextState){

    currentState = nextState;
    goToNextState = false;
  }

  switch(currentState){
    case INITIAL_STATE:{
      nextState = SCAN_FOR_BEST_POSITION_ALGO;
      break;
    }
    case SCAN_FOR_BEST_POSITION_ALGO:{
      currentBest = ScanForBestPosition2();
      nextState = SCAN_FOR_RECALIBRATION;
      goToNextState = true;
      break;
    }
    case SCAN_FOR_BEST_POSITION_ITER:{

      break;
    }
    case SCAN_FOR_RECALIBRATION:{
      float threshold = 0.15;
      nextState = SCAN_FOR_BEST_POSITION_ALGO;
      if (abs(currentBest - ScanPosition()) > threshold * currentBest){
        goToNextState = true;
      }
      break;
    }
    
  }
  // print out the value you read:
}
